;-------------------------------------------------------------------;
;   NameTrue.asm  v0.10                                 03/01/93    ;
;-------------------------------------------------------------------;
; An external replacement for the Dos 5.0 Truename feature which    ;
; allows those of us not running Dos 3.x and 4.x access to the same ;
; functionality. Works under Dos 5.0 and OS/2 for what it's worth.  ;
;                                                                   ;
; Usage:  Nametrue <pathspec>    or  Nametrue -?   for helpscreen   ;
;                                                                   ;
;  If <pathspec> not specified, truename of current dir obtained.   ;
;                                                                   ;
; Errorlevels:   0 = truename obtained    1 = invalid <pathspec>    ;
;                                                                   ;
; Uses Int21h service 60h (cannonicalize filename) to do the deed   ;
;                                                                   ;
;-------------------------------------------------------------------;
; v0.10 03/01/93  initial coding (adapted from my C demo version)   ;
;                                                                   ;
;-------------------------------------------------------------------;
; <Legal Status>                                                    ;
;  In the spirit of cooperation and education within the computing  ;
;  community, and in the hope that someone may benefit:             ;
;                                                                   ;
;  This program is released into the Public Domain.                 ;
;                                                                   ;
;  Please don't abuse this concept of sharing of information.       ;
;                                                                   ;
;-------------------------------------------------------------------;
; <General Disclaimer>                                              ;
;  Please note that this program was written for my personal use    ;
;  and that I am not a professional programmer. Thus, although I    ;
;  have made every effort to ensure that the code is bug free and   ;
;  performs as advertised, I can make no guarantees of suitability  ;
;  or performance - use at your own risk!                           ;
;                                                                   ;
;  In any case, this source code is provided for your inspection,   ;
;  enlightenment, and/or general amusement.                         ;
;                                                                   ;
;  I welcome any and all comments, criticisms, suggestions, or bug  ;
;  reports at the address below.                                    ;
;                                                                   ;
;-------------------------------------------------------------------;
;    Written for and assembled under Microsoft QuickC ver 2.01      ;
;      (Should also assemble under Masm with no problems)           ;
;-------------------------------------------------------------------;
;   Bruce Desmond      Sacramento, Ca.    Fidonet (1:203/555.9)     ;
;-------------------------------------------------------------------;

; Directives

_TEXT    segment byte public 'CODE'
         assume  cs:_TEXT, ds:_TEXT
         org     100h

first:   jmp     start

;-------------------------------------------------------------------;
; Equates
;-------------------------------------------------------------------;

;-------------------------------------------------------------------;
; Macros 
;-------------------------------------------------------------------;

;-------------------------------------------------------------------;
; Data buffer(s)
;-------------------------------------------------------------------;
retcode  db 1                        ;default retcode


; Warning! Two 128 byte data buffers for the cannonicalize function are
; are overlayed on the helpbuf below. Modify only after careful thought.
 
nameinp  db '.\',0

helpbuf  db 13,10
         db 'NameTrue.com  v0.10  03/01/93   external Truename replacement'
         db 13,10
         db 'Released to the Public Domain by Bruce Desmond (1:203/555.9)'
         db 13,10
nameout  db 13,10
         db 'usage: NameTrue <pathspec>   or  NameTrue -?  for this screen'
         db 13,10,13,10
         db 'if <pathspec> not specified, truename of current dir obtained.'
         db 13,10,13,10
         db 'Errorlevels:  0 = truename obtained  1 = invalid <pathspec>'
crlfstr  db 13,10
         db '$'

;----------------------start-of-main--------------------------------;

start:   mov     si,081h             ;psp offset
         mov     di,offset nameinp
         mov     cx,127
         cld

;-------------------------------------------------------------------;
; Strip any leading whitespace from passed cmd line

ledspa:  lodsb
         cmp     al,13               ;terminator?
         je      cannon
         cmp     al,32               ;leading space?
         je      ledspa
         cmp     al,9                ;leading tab?
         je      ledspa

;-------------------------------------------------------------------;
; See if help wanted

         cmp     al,'-'              ;help switch?
         jne     getspec

         cmp     byte ptr [si],'?'   ;help token next?
         jne     getspec

         mov     dx,offset helpbuf
         jmp     short done

getspec: stosb                       ;move any pathspec to namein
         lodsb
         cmp     al,13
         loopne  getspec

         mov     al,0                ;make asciiz string
         stosb

cannon:  mov     si,offset nameinp
         mov     di,offset nameout + 2
         mov     ah,60h
         int     21h

         jc      prexit

         mov     retcode,0

         mov     ah,2
         mov     cx,128
         mov     si,offset nameout

resloop: lodsb
         cmp     al,0
         je      prexit
         xchg    al,dl
         int     21h
         loop    resloop

prexit:  mov     dx,offset crlfstr   ;terminal crlf

;-------------------------------------------------------------------;
done:    mov     ah,9                ;display string in dx
         int     21h

         mov     ah,04ch             ;terminate
         mov     al,retcode
         int     21h

;-------------------------------------------------------------------;

;-------------------------------------------------------------------;
_TEXT    ends
         end     first
;-----------------------------end-of-code---------------------------;
